<script setup lang="ts">
const selectedOption = ref('combineCondition')
const isSearch = ref(false)
const fixBtn = {
  add: false,
  edit: true,
  delete: true
}

const tableHeaders = reactive([
  { title: '拜訪日期' },
  { title: '開始時間' },
  { title: '結束時間' },
  { title: '業務代表' },
  { title: '客戶簡稱' },
  { title: '科別' },
  { title: '客戶姓名' },
  { title: '產品' },
  { title: '主要工作' },
  { title: '工作細項' },
  { title: '臨時交辦' }
])

const tableData = reactive([
  {
    date: '2023/03/05',
    startTime: '10:00',
    endTime: '11:00',
    businessRepresentative: '王左鳳1',
    customerAbbreviation: '臺北榮總桃園分院',
    department: '家醫科',
    customerName: '王國書1',
    product: 'ADB SFD',
    mainWork: '進藥市調1',
    workItem: '進藥3-1',
    temporaryAssignment: null
  },
  {
    date: '2023/03/06',
    startTime: '11:00',
    endTime: '12:00',
    businessRepresentative: '王左鳳2',
    customerAbbreviation: '台大醫院2',
    department: '家醫科',
    customerName: '王國書2',
    product: 'ADB SFD2',
    mainWork: '進藥市調2',
    workItem: '進藥3-2',
    temporaryAssignment: null
  },
  {
    date: '2023/03/06',
    startTime: '11:00',
    endTime: '12:00',
    businessRepresentative: '王左鳳3',
    customerAbbreviation: '台大醫院3',
    department: '家醫科',
    customerName: '王國書3',
    product: 'ADB SFD3',
    mainWork: '進藥市調3',
    workItem: '進藥3-3',
    temporaryAssignment: null
  }
])

const pageObj = reactive({
  pageItems: 10, // 一頁秀幾筆
  currentPage: 1, // 當前頁數
  pageSize: 5 // 分頁中間數字最多顯示的數目
})

// 總頁數
const totalPage = computed(() => {
  return Math.ceil(tableData.length / pageObj.pageItems)
})

const nowPage = computed(() => {
  const min = (pageObj.currentPage - 1) * pageObj.pageItems
  const max = min + pageObj.pageItems - 1
  return { min, max }
})

// 篩出來渲染的資料
const showData = computed(() => {
  return tableData.filter((item, index) => {
    return index >= nowPage.value.min && index < nowPage.value.max + 1
  })
})

const onCreated = (val: any) => {
  console.log('parent add', val)
}

const onEdit = (val: any) => {
  console.log('parent edit', val)
}

const onDelete = (val: any) => {
  console.log('parent delete', val)
}

const turnPage = (val: any) => {
  pageObj.currentPage = val
}

function onSubmit() {
  isSearch.value = true
}
</script>

<template>
  <main class="container-fluid">
    <header>
      <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
          <li class="font-zh-small-regular breadcrumb-item">
            <a href="#">業務活動資料登錄</a>
          </li>
          <li
            aria-current="page"
            class="font-zh-small-regular breadcrumb-item active"
          >
            業務拜訪記錄查詢
          </li>
        </ol>
      </nav>
      <div class="d-flex justify-content-end w-100">
        <img
          alt="header-illustration"
          class="header-illustration"
          src="@/assets/images/header-illustration.svg"
        />
      </div>
      <div class="function-group">
        <div class="display-info">
          <h3 class="font-zh-h3">業務拜訪記錄查詢</h3>
          <div class="interact-button-list d-flex">
            <button
              class="btn btn-middle-gray-200 font-zh-button d-flex justify-content-center align-items-center"
              type="button"
            >
              <p>新增</p>
              <div class="icon-create"></div>
            </button>
            <button
              class="btn btn-middle-gray-200 font-zh-button d-flex justify-content-center align-items-center"
              type="button"
            >
              <p>匯出 Excel 檔</p>
              <div class="icon-export"></div>
            </button>
          </div>
        </div>
      </div>
      <div class="dual-operation-board card">
        <h3 class="font-zh-h3 text-color-main">查詢條件</h3>
        <form @submit.prevent="onSubmit">
          <div class="card-header">
            <div class="row">
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >開始日期</label
                  >
                  <common-calendar-date />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userPassword"
                    >結束日期</label
                  >
                  <common-calendar-date />
                </div>
              </div>
            </div>
          </div>
          <div class="card-body">
            <div class="sub-title d-flex align-items-center">
              <h3 class="font-zh-h3 text-color-main">查詢模式</h3>
              <div class="form-check-list d-flex">
                <div class="form-check">
                  <input
                    id="combineCondition"
                    v-model="selectedOption"
                    class="form-check-input"
                    name="option"
                    type="radio"
                    value="combineCondition"
                    checked
                  />
                  <label
                    class="font-zh-p-medium form-check-label"
                    for="combineCondition"
                  >
                    組合條件
                  </label>
                </div>
                <div class="form-check">
                  <input
                    id="clientName"
                    v-model="selectedOption"
                    class="form-check-input"
                    name="option"
                    type="radio"
                    value="clientName"
                  />
                  <label
                    class="font-zh-p-medium form-check-label"
                    for="clientName"
                  >
                    特定客戶姓名
                  </label>
                </div>
              </div>
            </div>
            <div
              v-show="selectedOption === 'combineCondition'"
              class="row align-items-end"
            >
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >業務代表</label
                  >
                  <common-select
                    v-model="businessRepresentValue"
                    :select-list-data="businessRepresentList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >客戶簡稱</label
                  >
                  <common-select
                    v-model="clientValue"
                    :select-list-data="clientList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >科別</label
                  >
                  <common-select
                    v-model="divisionValue"
                    :select-list-data="divisionList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >產品簡稱</label
                  >
                  <common-select
                    v-model="productValue"
                    :select-list-data="productList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >主要工作</label
                  >
                  <common-select
                    v-model="mainJobValue"
                    :select-list-data="mainJobList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >客戶等級</label
                  >
                  <common-select
                    v-model="clientLevelValue"
                    :select-list-data="clientLevelList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >臨時交辦</label
                  >
                  <div class="untitled-item form-check-item">
                    <input
                      id="checkbox"
                      class="form-check-input"
                      type="checkbox"
                    />
                    <label
                      class="font-zh-p-medium form-check-label"
                      for="checkbox"
                    >
                      臨時交辦
                    </label>
                  </div>
                </div>
              </div>
              <div class="col-3">
                <div class="d-grid gap-2">
                  <button
                    class="btn btn-large-secondary font-zh-button d-flex justify-content-center align-items-center"
                    type="submit"
                  >
                    <p>查詢</p>
                    <div class="icon-search"></div>
                  </button>
                </div>
              </div>
            </div>
            <div
              v-show="selectedOption === 'clientName'"
              class="row align-items-end"
            >
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >客戶</label
                  >
                  <common-select
                    v-model="clientValue"
                    :select-list-data="clientList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >科別</label
                  >
                  <common-select
                    v-model="divisionValue"
                    :select-list-data="divisionList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >客戶姓名</label
                  >
                  <common-select
                    v-model="clientNameValue"
                    :select-list-data="clientNameList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="d-grid gap-2">
                  <button
                    class="btn btn-large-secondary font-zh-button d-flex justify-content-center align-items-center"
                    type="submit"
                  >
                    <p>查詢</p>
                    <div class="icon-search"></div>
                  </button>
                </div>
              </div>
            </div>
          </div>
        </form>
      </div>
      <div>
        <basic-table
          :fix-btn="fixBtn"
          :table-data="showData"
          :table-headers="tableHeaders"
          @add="onCreated"
          @delete="onDelete"
          @edit="onEdit"
        />
        <table-pagination
          :page-obj="pageObj"
          :total-page="totalPage"
          @turn-page="turnPage"
        />
      </div>
    </header>
  </main>
</template>

<style lang="scss" scoped>
/** style */
</style>
